/**************************************************************************
 *
 * Interface module of type UI for a cc65
 * application.
 *
 * This code skeleton was created using TempC by Joseph Rose.
 * This code is not copyrighted.  The end progammer may read,
 * analyze or modify it as he/she wishes.
 *
 **************************************************************************/

/* Standard includes: */
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

/* Special headers */
#include <conio.h>

/* You should include this module's header here. */
#include "menu.h"

//Midddleman for setting unselected color.
void setunselcol (void)
#ifdef __C128__
{textcolor (col_unselect);}
#else
{textcol=col_unselect;}
#endif

//Inline asm for reverson/reversoff functions, don't use () in call.
#ifdef __C64__
#define reverson  __asm__ ("\tlda\t#$80\n\tsta\t$C7\n")
#define reversoff __asm__ ("\tlda\t#$00\n\tsta\t$C7\n")
#elif defined __C128__
#define reverson  __asm__ ("\tlda\t#$80\n\tsta\t$F3\n")
#define reversoff __asm__ ("\tlda\t#$00\n\tsta\t$F3\n")
#elif defined __C16__
#define reverson  __asm__ ("\tlda\t#$80\n\tsta\t$C2\n")
#define reversoff __asm__ ("\tlda\t#$00\n\tsta\t$C2\n")
#endif
/* Array holding file names. */
char files [maxfiles][lenfilename+1];

//char* __fastcall__ geteaddr (unsigned char en)
//{return files[en];}

char* __fastcall__ geteaddr (unsigned char en);
char* __fastcall__ geteaddrcur (void);

extern unsigned char e, x, c, numfiles;
struct cbm_dirent d;
#pragma zpsym ("e")
#pragma zpsym ("x")
#pragma zpsym ("c")
#pragma zpsym ("numfiles")

//Display current entry in menu.
void __fastcall__ DispDirEntry (void);


/* Function to select a program to run. */
void SelPrg (void)
{
	//Clear screen.
	clrscr();
	/* Open directory on device 8. */
	if (cbm_opendir(1,8)) {//Quit on error
		setunselcol ();//textcol=col_unselect;
		prints ("\nCan't load directory."); goto quiterr;
	}
	/* Read disk label. */
	cbm_readdir (1,&d);
	//Center and print as a 16-char title.
#ifdef __C128__
	tabx=c;			//set in the getcolumns() asm. function
				//in zprout.s on C128
	textcolor (col_title);
#else
	tabx=12;		//const center on 40-column computers
	textcol=col_title;
#endif
	reverson; printscr (d.name);
	setunselcol ();
	/* Read directory entries until end of dir. or overflow. */
	// (e is set to 0 in start-up code)
	for (;e<columns && !cbm_readdir(1, &d);)
	{
		/* Skip if not a program. */
		if (d.type!=CBM_T_PRG) continue;
		/* Store program name. */
		__asm__ ("\tjsr\t_geteaddrcur\n"
			 "\tsta\tptr2\n\tstx\tptr2+1\n"
			 "\tldy\t#16\n"
			 "@zz1:\tlda\t_d,y\n"
			 "\tsta\t(ptr2),y\n"
			 "\tdey\n"
			 "\tbpl\t@zz1\n");
		/* Display program name. */
		DispDirEntry ();
		//Advance to next entry.
		++e;
	}
	numfiles=e;
	cbm_closedir (1); /* Close directory. */
	//If disk blank, error.
	if (!numfiles){
		prints ("\nNo programs on disk."); goto quiterr;//e=-1;
	}
	/* Display select prompt. */
	// Set to bottom of screen and set to first selection.
	__asm__ ("\tldy\t#0\n\tsty\t_e\n\tldx\t#24\n\tclc\n\tjsr\t$fff0\n");
	// Set color.
#ifdef __C128__
		textcolor (col_prompt);
#else
		textcol=col_prompt;
#endif
	// Write prompt.
	prints ("Select the program to run.");
	//Menu loop: get user selection.
	do
	{
		/* Highlight current selection. */
		reverson;
#if defined __C16__ || defined __PLUS4__ || defined __C64__
		textcol=col_hilite;
#elif defined __C128__
		textcolor (col_hilite);
#endif
		//Write current selection.
		DispDirEntry ();
		//Get ket into c.
		__asm__ ("@zz:\tjsr\t$FFE4\n\ttax\n\tbeq\t@zz\n\tsta\t_c\n");
		/* Unhilight and write. */
		reversoff;
		setunselcol ();
		DispDirEntry ();
		/* Process key. */
		switch (c)
		{
		/* If down, advance and wrap-around. */
		case CH_CURS_DOWN:
			__asm__ ("\tldx\t_e\n"
				 "\tinx\n"
				 "\tcpx\t_numfiles\n"
				 "\tbcc\t@zz3\n"
				 "\tldx\t#0\n"
				 "@zz3:\tstx\t_e\n");
			break;
		/* If up, move back and wrap-around. */
		case CH_CURS_UP:
			__asm__ ("\tdec\t_e\n\tbpl\t@zz2\n"
				 "\tldx\t_numfiles\n\tdex\n\tstx\t_e\n"
				 "@zz2:\n");
			break;
		/* If Return, return program name. */
		case '\n':
			//strcpy (prg, files[e]); //return;
			/*strcpy2 (prg, geteaddrcur());*/ return;
		/* If return or cancel, exit routine.
		 * If cancel, returned program is already nullified
		 * upon call to this routine. */
		case CH_STOP:
//#ifdef __C128__
//			textcolor (col_unselect);
//#else
			//setunselcol ();//textcol=col_unselect;
//#endif
			prints ("\fProgram aborted!");
			goto quiterr;//e=-1; return;
			//exit(0);

		}
	} while(1);
quiterr:
	e=-1;
}

