.include	"zeropage.inc"
;_files is an 80-element array of type char[17] containing the files.
;_prints is a quick puts() function that outputs a string to the screen
;using the kernal's chrout routine.
.import		_files, _prints

;_geteaddrcur returns the address of the current entry given in _e,
;_DispDirEntry displays a menu entry, and
;_WriteEntry writes the current selection to the current pos. on the
;screen.
.export		_geteaddrcur, _DispDirEntry, _WriteEntry

;_e is the current menu selection #,
;_c holds the current key-press and a temp. centering # for displaying the
;title on a C128 ,
;_x is the column # of the current menu option, and
;_numfiles is the # of entries on the disk.
.exportzp	_e, _c, _x, _numfiles

;For the C128:
.ifdef __C128__
.export		_getcolumns	;Routine to get # columns and calculate
				;centerig x-pos for title.
.exportzp	_columns	;Returned # columns on the screen.
.endif

;The _e variable was moved here to support an optimization on the C64
;version.  The optimization was later removed due to an incompatibility, but
;this line wasn't corrected.
.ifdef __C64__
_e=$4B
.endif

;Define ZP variables:
.zeropage
.ifndef __C64__
_e:		.res	1
.endif
_x:		.res	1
_c:		.res	1
_numfiles:	.res	1
.ifdef __C128__
_columns:	.res	1
.endif

;The following routine calculates the address of a given filename in the
;list.  The element # is in _e.
.code
;This entry gets the address of the current pos.
_geteaddrcur:
	lda	_e
;This entry calculates the address of the file whose # is passed in .A.
;_geteaddr:
;Quick-multiply by 17:
	;sta	regbank+4		;Store orig. e as word in regbank+4.
	ldx	#0
	;stx	regbank+5
	stx	tmp1			;High byte of shift calc. = 0.
	asl				;Multiply by 16 using shifts.
	asl				;Max. value of e is 39, so high bit is
.ifdef __C128__
	rol	tmp1			;(79 on C128)
.endif
	asl				;not needed immediately.
	rol	tmp1
	asl
	rol	tmp1
	;clc				;Add orig. e for *17.
	adc	_e;regbank+4
	ldx	tmp1
	bcc	*+4
	inx
	;inc	tmp1
	clc				;Add pointer to files array.
	adc     #<(_files)
	tay
	;lda	tmp1
	txa
	adc     #>(_files)
	tax
	tya
	;ldx	#>(_files)
	
	;ldx	#>(_files)
	;bcc	*+3
	;inx
	rts

_DispDirEntry:
;Calculate X coordinate.
.ifdef __C128__			;Needs extra work on a C128:
	lda	_e		;Get entry # and set column to 0.
	ldx	#0
@lp:
	cmp	#20		;Test entry # and end loop if <20
	bcc	@lp2		;(on this column).
	sbc	#20		;Subtract 20 from entry,
	tay
	txa
	clc			;add 20 to column for next column and
	adc	#20
	;sbc	#20
	tax
	tya
	bcc	@lp		;loop.  (Carry overflow not expected)
@lp2:
	txa			;Store as column and set as .X to PLOT
	sta	_x		;kernal routine.
	tay
.else				;For other computers,
	ldy	#0		;assume column 0.
	lda	_e		;If entry >=20, use column 20 instead.
	cmp	#20
	bcc	*+4
	ldy	#20
	sty	_x		;Set.
.endif
;Get y co.
	sec
	lda	_e		;Get entry.

	sbc	_x		;Subtract column # to get entry in column and
	adc	#1		;add 2 (explicit 1 + carry assumed set)
	tax			;for screen .Y.
	jsr	$fff0		;Call PLOT (carry already clear).
;Entry point to write to current screen pos.
_WriteEntry:
	jsr	_geteaddrcur
	jmp	_prints


.ifdef __C128__
;On a C128, get screen columns and the pos. of centered disk name.
_getcolumns:
	lda	#40
	ldx	#12
	bit	$D7
	bpl	*+6
	lda	#80
	ldx	#32
	;lda	#0
	sta	_columns
	stx	_c
	rts
.endif

